/* 
    Ec  Vers  4.1-0    Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

#include "ec_data.h"


#if LANG_FR == 1
#include "ec_me_fr.i" 
#endif

#if LANG_EN == 1
#include "ec_me_en.i"
#endif

#if LANG_DE == 1
#include "ec_me_de.i"
#endif

/* Libelle des type de note */
struct { char *label;}
 lib_typ_not []=
{
  { LIB_TYP_NOT_NBR_MVT },
  { LIB_TYP_NOT_NBR_MAT },
  { LIB_TYP_NOT_NBR_MAT_INC },
  { LIB_TYP_NOT_NBR_PAT },
  { LIB_TYP_NOT_NBR_PAT_INC },
  { LIB_TYP_NOT_NBR_MAT_RF },
  { LIB_TYP_NOT_NBR_PAT_RF },
  { LIB_TYP_NOT_NBR_FOU },
  { LIB_TYP_NOT_MOB_PIE },
  { LIB_TYP_NOT_COU_PIE },
};

/* Separateur*/
char tc_sep_tir[]="\n-------------------------------------------------------------------------------";
char tc_sep_tir_120[]="\n-----------------------------------------------------------------------------------------------------------------------";
char tc_sep_ast[]="\n*******************************************************************************";

/* Pagination pour toutes les fonction d'affichage necessitant plus d'1 page */
enum {e_pas_aff,e_aff_not_1,e_aff_not_2,st_aff_dim} e_cur_aff;		/* affichage en cours */
struct st_aff
{
  int i_nbr_lig_pag;
  int i_cur_pag;
  int i_fir_pag;
  int i_las_pag;
  int (*pf_aff)();
  void * arguments;
};
struct st_aff tst_aff[st_aff_dim];

#define TRUE  1
#define FALSE 0


/*****************************************************************************/
/*  Main                                                                     */
/*****************************************************************************/
int main()
{
	mnu_cde();

	return 0;
}
/*****************************************************************************/
/*  test  bug                                                               */
/*****************************************************************************/


void test6 (void)
{
  /* printf("\n Couverture= %i pour  nn=%i camp=%i",cou_pie(D2,BLANC),D2,BLANC); */
  printf("\n Couverture= %f  camp=%i",eva_cou_cam(BLANC),BLANC); 
  printf("\n Couverture= %f  camp=%i",eva_cou_cam(NOIR),NOIR); 
}
void test (void)
{
  sim_aut();

}
void rec_bug(void)
{
  test_aut();
}
void test8 (void)
{
  char str[10]="         ";
  int i=0;
  int c;

  c=getchar();

  while( i<10) 
    {  
      c=getchar();
      
      if (c !=10 )
	str[i++]=c;
      else 
	break;
    }	
  str[i]='\0';
  printf("\n%s->",str);
  for(i=0;i<10;i++) printf("/%i",str[i]);
}
void test9 (void)
{
  char c;
  unsigned long x,y=0;
  float  start,end;
  float time;

  /* fflush(stdin);*/
  start =clock();
  for(x=0;x<=100000;x++)
    y=x;
  
    /* printf("\nSaisie");
       c=getchar();*/
 
  end = clock();
  if (start != -1 && end != -1)
    time=(float)(end-start)/(float)CLOCKS_PER_SEC;
  else
    {
      time =0;
      printf("\nErr");
    }
  c=getchar();

  printf("\n char %c start: %e end: %e  CLK_TCK: %lu cpt %lu Time elpsed %e",c,start,end,CLOCKS_PER_SEC,y,time);

}

void test10 (void)
{
  time_t start,end;
  unsigned long x,y;
  double elapsed;

  start =time (NULL);
  for(x=0;x<=1500000000;x++)
    y=x;

  end = time (NULL);

  elapsed = (double)(end-start);

  printf("\n cpt %li Time elpsed %e",y,elapsed);

}
/*
void  test11 ()
{
  char c;
  struct timeval td,tf;
  float deb,fin, ela;
  float deb1,fin1, ela1;

  gettimeofday(&td,NULL);
    c=getchar();
    c=getchar();
    gettimeofday(&tf,NULL);
 
    deb = (float)td.tv_sec +( (float)td.tv_usec * (float) 1.0E-6);
    fin = (float)tf.tv_sec +( (float)tf.tv_usec * (float) 1.0E-6);
    ela = fin-deb;

    deb1 = (float)td.tv_sec ;
    fin1 = (float)tf.tv_sec ;

    ela1 = fin1-deb1;

   printf("\nDeb1 %f fin1: %f Elapsed1: %f",deb1,fin1,ela1); 

   printf("\nDeb %f fin: %f Elapsed: %f",deb,fin,ela); 




}
void test12 (void)
{

 
}
*/
/*****************************************************************************/
/*  Affichage                                                                */
/*****************************************************************************/

/*  Menu de commande                                                         */

void mnu_cde (void)
{
	char tc_com[80];
	
	int i_mei_mvt=0;	/* N du meilleur mvt */
	int i_mvt=0;		/* N mvt */
	int i_msg=0;              /* message retour de fonction */

	/* argument p:play et m:move */
	char tc_dep[3];               		/* case de depart ex:A1 */
	char tc_arr[4];               		/* case d'arrive ex:B2 ou A8C pour pion en cavalier */

	/* initialisation programme */
	ini_pgm();

	/* cote d'affichage */
	i_cot_aff               =  BLANC;

	/*pour sauvegarde et acces autre fct sauf simu qui attend param */
	i_pro_sim_niv	= 3;			/* niveau par default */
	i_pro_sim_inc	= 2;			/* niveau par default */

	printf("%s",tc_sep_tir);
	
	if(c_jou[1] == 'h')
			aff_ech(NOIR);
	else
			aff_ech(BLANC);

	while (1)
	{
	  i_aff_cal_cou 		= 1;

		printf("%s",tc_sep_tir);
		if(i_pro_act>0)
		{
			printf("\n");
			/* Mouvement precedent */
			printf( LIB_08_MVT_PRE );
			printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_ori_n]);
			printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_n]);
			printf("%c",pro_pio_tra_tmvt_lpie (ts_hst_pro[i_pro_act].i_typ_mvt));
		}
		else
		{
			printf("\n");
		}
		if(ts_hst_pro[i_pro_act+1].i_cam== BLANC)
		  /* Tour au blanc */ 
		  printf( LIB_10_TOU_BLA );
		else
		  {
		    /* tour au noir */
		    printf( LIB_10_TOU_NOI );
		  }
		printf(" ");
		/* Niveau Increment Cote(machine humain)*/
		printf( LIB_44_PRO_LEV_INC_COT ,
		i_pro_act,
		i_pro_sim_niv,
		i_pro_sim_inc
		);
		/* Version eva */
		printf (" V:%02u",i_ver_eva);

		/* Aide:tapez h */  
		printf(" ");
		printf( LIB_11_AIDE );
		printf("\n>");
		sai_com(tc_com);
		
		switch ( tolower (tc_com[0]) )
		  {
		  case '+':
		    aff_nex_pag();
		    break;
		  case '-':
		    aff_pre_pag();
		    break;

		    /*case 'p':   */                /*print */
		  case  CDE_PRINT :                   /*print */

		    switch ( tolower (tc_com[1]) )
		      {
		      case CDE_HISTORY :                   /* history */
			e_cur_aff=e_pas_aff;
			aff_hst(i_pro_act,i_pro_sim_max_inf);
			break;

		      case '0':                       
			e_cur_aff=e_pas_aff;
			aff_hst(0,i_pro_act);
			break;

		      case CDE_PIE :                   /* piece */
			e_cur_aff=e_pas_aff;
			if (tc_com[2]== '0')
			  aff_pie(BLANC);
			else
			  aff_pie(NOIR);
			break;

		      case CDE_BOARD :                   /* board */
			e_cur_aff=e_pas_aff;
			aff_ech(i_cot_aff);
			break;

		      case  CDE_MARK :                   /* mark */
	
			switch (tc_com[2])
			  {
			  case '1':  
			    e_cur_aff=e_aff_not_1;			
			    i_msg=  aff_not_1(&i_mei_mvt);
			    if(i_msg<0)
			      /* Calcul necessaire: taper r*/ 
			      aff_mes_uti(i_msg);			
	
			    break;
			  case '2':
			    e_cur_aff=e_aff_not_2;			
			    i_msg=  aff_not_2(&i_mei_mvt);
			    if(i_msg<0)
			      /* Calcul necessaire: taper r*/ 
			      aff_mes_uti(i_msg);			
		    
			    break;
			  default:
			    e_cur_aff=e_aff_not_1;			
			    i_msg=  aff_not_1(&i_mei_mvt);
			    if(i_msg<0)
			      /* Calcul necessaire: taper r*/ 
			      aff_mes_uti(i_msg);			
			    break;
			  }
		break;

		      case CDE_INITIAL_MVT :                   /* mouvement Iinital */
			e_cur_aff=e_pas_aff;
			if (isdigit(tc_com[2]))
			    i_mvt=atoi(&tc_com[2]);
			i_msg = aff_mvt_ini(i_mvt);
			if (i_msg<0) 
			  aff_mes_uti(i_msg);			
			break;

		      default:
			mnu_hlp();
			break;

		      }
		    break ;

		  case CDE_MOVE :                  	/* move */
		    e_cur_aff=e_pas_aff;
		
		    switch ( tolower (tc_com[1]) )
		      {
		      case CDE_MOVE :               
			/* reponsonce auto de l'ordi */
			if(isdigit(tc_com[2]))
			{
			  /*  une coordonne  pourrait tre confondue avec l'instrution deplace*/
			  strncpy(tc_dep,&tc_com[1],2);
			  strncpy(tc_arr,&tc_com[3],3);
			  i_msg=jou_int_ctl(tc_dep,tc_arr);
	
			}
			   else
			{
			  strncpy(tc_dep,&tc_com[2],2);
			  strncpy(tc_arr,&tc_com[4],3);
			  i_msg=jou_int_jou(tc_dep,tc_arr);
			}
			break;
			
		      default:
			/* mouvement sans reponse de l'ordi */	  
			  strncpy(tc_dep,&tc_com[1],2);
			  strncpy(tc_arr,&tc_com[3],3);             
			i_msg=jou_int_ctl(tc_dep,tc_arr);
			break;
		      }
		    if (i_msg<0) 
		      aff_mes_uti(i_msg);
		    aff_ech(i_cot_aff);
		    break;

		  case CDE_BACK :                  	/* annule coup */
		    e_cur_aff=e_pas_aff;
		    i_msg=ann_cou_int();
			if(i_msg<0)	
			  aff_mes_uti(i_msg);
			else
			  aff_ech(i_cot_aff);
			break;

		  case CDE_RECK :                   /* reckon  */
		    e_cur_aff=e_pas_aff;
		    switch ( tolower (tc_com[1]) )
		      {
			/* reckon and move */
		      case CDE_MOVE :                   
			{
			  i_msg=sim_jou();
			  if(i_msg<0)
			    {
			      aff_mes_uti(i_msg);
			    }	
							
			  aff_ech(i_cot_aff);
			}
			break ;
			/* reckon and print */
		      default :                  
			{
			  i_mei_mvt=simul_eva(i_pro_sim_niv,
					      i_pro_sim_inc);
			  if (i_mei_mvt>=0)
			    {
			      e_cur_aff=e_aff_not_1;
			      tst_aff[e_aff_not_1].i_cur_pag=0;
			      i_msg=aff_not_1(&i_mei_mvt);
			      if (i_msg<0) aff_mes_uti(i_msg);
			    }
			  else
			      aff_mes_uti(i_mei_mvt);	
			}
			  break ;
		      }
		    break;
		  case CDE_SIDE :                   /* side choice  */
		    if(i_cot_aff==0)
		      i_cot_aff=1;
		    else
		      i_cot_aff=0;
		    aff_ech(i_cot_aff);
		    break ;

		  case CDE_LEVEL :                   /* level */
		    i_msg=chg_lvl(tc_com);
		    if (i_msg<0)
		    aff_mes_uti(i_msg); /* oraganisation */
		    break ;
			
		  case CDE_FILE :					/* fichier */
			
		    switch ( tolower (tc_com[1]) )
		      {
		      case CDE_SAVE :			/* sauvegarde */
			i_msg=sav_dsk("ec.std");
			if(i_msg<0) aff_mes_uti(i_msg);
			break;

		      case CDE_LOAD :			/* load */
			e_cur_aff=e_pas_aff;
			i_msg=rst_dsk("ec.std");
			if (i_msg<0)
			  aff_mes_uti(i_msg);
			else
			  aff_ech(i_cot_aff);
			break;

		      case 'w':			/* load  fichier de travail*/
		      e_cur_aff=e_pas_aff;
			i_msg=rst_dsk("ec.wrk");
			if(i_msg<0)
			  aff_mes_uti(i_msg);
			else
			  aff_ech(i_cot_aff);
			break;
		      }
		    break;
		  case CDE_INIT :                   /* Init  */
		    e_cur_aff=e_pas_aff;
		    ini_pgm();
		    aff_ech(i_cot_aff);
		    break;
		  
		  case CDE_HELP :                   /* help */
		    mnu_hlp();
		    break;

		  case CDE_QUIT :                   /* quit */
		    return ;

		  case 't':                   /* test */
		    e_cur_aff=e_pas_aff;
		    test8() ;
		    break;

		  case 'u':                   /* test */
		    e_cur_aff=e_pas_aff;
		    rec_bug() ;
		    break;

		  case 'x':                   /* test */
		    cho_ver() ;
		    break;

		  default:
		    /* Commande inconnue tapez h pour aide*/
		    if(tc_com[0]!='\0')
		    {
		      printf(tc_sep_ast );
		      printf("\n");
		      printf( LIB_30_CDE_INC );
		      printf(tc_sep_ast );
		      printf("\a");
		    }
		    break;
		  }
		fflush(stdin);
	}

}
void cho_ver (void)
{
  int ver;
    scanf("%i",&ver);
  if (tpf_eva[ver] != NULL)
    {
      i_ver_eva = ver;
      pf_eva = tpf_eva[ver];
    }
  else
    printf ("\nErreur Num Evaluation");

}
int chg_lvl(char *tc_com)
{
  int cpt,cpt2;
  char tc_pro_sim[5];
  char tc_pro_sim_inc[5];
  int pro_sim,pro_sim_inc;
  cpt2=0;
  for(cpt=1;cpt < 80 ;cpt++)
    {
      if (tc_com[cpt]=='.')
	{
	  tc_pro_sim[cpt2]='\0';
	  break;
	}
      else
	{
	  tc_pro_sim[cpt2++]=tc_com[cpt];
	}
    }
  pro_sim=atoi(tc_pro_sim);
  cpt2=0;
 for(cpt=cpt+1;cpt < 80 ;cpt++)
    {
      if (isdigit(tc_com[cpt]))
	{
	  tc_pro_sim_inc[cpt2++]=tc_com[cpt];
	
	}
      else
	{
	  tc_pro_sim_inc[cpt2]='\0';
	  break;
	}
    }
  pro_sim_inc=atoi(tc_pro_sim_inc);

   return (cho_niv(pro_sim,pro_sim_inc));


}
/* affichage aide du menu cde  */
void mnu_hlp (void)
{
	/*move                   : m  A7A8C (C only when pawn to Knight) */
	printf( LIB_80_AID_MOV );
	/*move and move          : mm  A7A8C (the computer reply automatically) */
	printf( LIB_80_AID_MMV );

	/*reckon and move        : rm*/
	printf( LIB_80_AID_RMV );

	/*back                   : b */
	printf( LIB_80_AID_BAC );

	/*side (choice)    */
	printf( LIB_80_AID_SCH );

	/*level (deepness)       : l 4 2*/
	printf( LIB_80_AID_LEV );

	/*file save              : fs (save game)*/
	printf( LIB_80_AID_FS );
	/*file load              : fl (load game)*/
	printf( LIB_80_AID_FL );
	
	/*New game : i*/
	printf( LIB_80_AID_INI );

	/*quit                   : q*/
	printf( LIB_80_AID_QUI );

	/*reckon and print marks : r*/
	printf( LIB_80_AID_RPM );
	/*print board            : pb*/
	printf( LIB_80_AID_PBO );
	/*print marks            : pm*/
	printf( LIB_80_AID_PMK );
	/*print marks 2          : pm2*/
	printf( LIB_80_AID_PMK2 );
	/*print initial move     : pi 0 (for the first initial move)*/
	printf( LIB_80_AID_PIM );

	/*help                   : h*/
	printf( LIB_80_AID_HLP );

}


/*  Affichage de l'echiquier */
void aff_ech (int i_cam)
{
  int x,y;
  int i_pos_n=0;
  int i_lib_lic;
  char b =' ';       /* Case noire	*/
  char n =' ' ;	      /* Case blanche	*/

  int b_n; /* blanc ou noir: 1 ou -1 */
  char c_lib_pie;

  char tc_lib_lic[16][41] ;
  strcpy( tc_lib_lic[0], LIB_8_VERSION );
  strcat( tc_lib_lic[0], " " );
  strcat( tc_lib_lic[0], LIB_31_COPYRIGHT );
 
  strcpy( tc_lib_lic[1], " " ) ;
  strcpy( tc_lib_lic[2], LIB_31_EMAIL );
  strcpy( tc_lib_lic[3], LIB_32_SITE );
  strcpy( tc_lib_lic[4], " " ) ;

  strcpy( tc_lib_lic[5], LIB_40_L1_LICENCE );
  strcpy( tc_lib_lic[6], LIB_40_L2_LICENCE );
  strcpy( tc_lib_lic[7], LIB_40_L3_LICENCE );
  strcpy( tc_lib_lic[8], LIB_40_L4_LICENCE );
  strcpy( tc_lib_lic[9], LIB_40_L5_LICENCE );
  strcpy( tc_lib_lic[10], LIB_40_L6_LICENCE );
  strcpy( tc_lib_lic[11], LIB_40_L7_LICENCE );
  strcpy( tc_lib_lic[12], " " );
  strcpy( tc_lib_lic[13], LIB_20_ADR_1 );
  strcpy( tc_lib_lic[14], LIB_20_ADR_2 );
  strcpy( tc_lib_lic[15], LIB_20_ADR_3 );

  /*printf("%s",tc_sep_tir);*/

  /* pour les noir  (i_cam = 1) les noir sont en bas */
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");

  printf("    %s",tc_lib_lic[0]);
  printf("\n-+===============================+-");
  printf("    %s",tc_lib_lic[1]);
  i_lib_lic = 2;

  if (i_cam == NOIR)
    {
 
      b_n = 1;

	
      for (y=1;y<=8;y++)

	{	
	
	  b_n *=-1;

	  printf("\n%i",y);
	  for (x=8;x>=1;x--)
	    {
	      i_pos_n = (y*10)+x;
	      if (x<8)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
				  
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);
	
		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);                                
	  if ((i_lib_lic<16 && i_pro_act==0)|| i_lib_lic <4) 
	    printf("    %s",tc_lib_lic[i_lib_lic++]);
	  if (y<8)
	    printf("\n-+ - + - + - + - + - + - + - + - +-"); 
	  if ((i_lib_lic<16 && i_pro_act==0)|| i_lib_lic<4) 
	    printf("    %s",tc_lib_lic[i_lib_lic++]);

	}
  
    }
  else
    /* pour les blanc (i_cam = BLANC) les blanc sont en bas */
    {


      b_n = 1;
 
      for (y=8;y>=1;y--)
	{
	  b_n *=-1;
	  printf("\n%i",y);
	  for (x=1;x<=8;x++)
	    {
	      i_pos_n= (y*10) + x;
	      if (x>1)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);

		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
	  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);
	  if ((i_lib_lic<16 && i_pro_act==0)|| i_lib_lic<4)
	    printf("    %s",tc_lib_lic[i_lib_lic++]);
	  if (y>1)
	    printf("\n-+ - + - + - + - + - + - + - + - +-");
	  if ((i_lib_lic<16 && i_pro_act==0)|| i_lib_lic<4) 
	    printf("    %s",tc_lib_lic[i_lib_lic++]);

	}
    }
    printf("\n-+===============================+-");
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");


}

/*  Affichage  piece   */
void aff_pie (int i_cam)
{
	int i_pie ;
	if(i_cam!=0 && i_cam!=1)
	  return;
	printf("%s",tc_sep_tir);
	/* \nTableau camp :  %d  */ 
	printf( LIB_AFF_PIE_L01 ,i_cam);
	/*  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir */
	printf( LIB_AFF_PIE_L02 );
	for (i_pie = 0; i_pie < 18;i_pie++)
	  aff_pie_lin(i_pie,tpts_pie[i_cam]+i_pie);
	

}
/*  Affichage  piece presentes   */
void aff_pie_pre (int i_cam)
{
	struct st_pie *pts_pie_ct;
	if(i_cam!=0 && i_cam!=1)
	  return;
	printf("%s",tc_sep_tir);
	/* \nTableau camp :  %d  */ 
	printf( LIB_AFF_PIE_L01 ,i_cam);
	/*  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir */
	printf( LIB_AFF_PIE_L02 );
	pts_pie_ct=tpts_pie[i_cam] ;

	for (	pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		;
		pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)
	  {
	    aff_pie_lin(0,pts_pie_ct);
	    if (pts_pie_ct->i_pie_sui==17) break;
	  }

}
void aff_pie_lin(int i_pie,struct st_pie *ptst_pie)
{
  		printf("\n%d\t",i_pie);
		printf("%d\t",ptst_pie->i_pie_sui);
		printf("%d\t",ptst_pie->i_pie_pre);
		printf("%s\t",tc_lib_cas[ptst_pie->i_pos_n]);
		printf("%i\t",ptst_pie->i_for);
		printf("%c\t",ptst_pie->c_lib_pie);

}
/*  Affichage  historique  */

void aff_hst (int i_pro_deb, int i_pro_fin)
{ 
/*  Affichage  historique  */
	int pro;
	if (i_pro_fin == 0) i_pro_fin = pts_hst_pro->i_pro;

	printf("%s",tc_sep_tir);
	/* \nTableau historique prof de %d a %d */
	printf( LIB_HST_ENT_L01 ,i_pro_deb,i_pro_fin);
	/* \nPro\tId\to_x\to_y\tx\ty\tId2 */
	printf( LIB_HST_ENT_L02 );
	/* \n\tTyp_mvt\tDir_pri\tDir_dem\tDir_dpc */
	printf( LIB_HST_ENT_L03 );
	/* \n\tNote\tNot max\tPat\tMat */
	printf( LIB_HST_ENT_L04 );

	for (pro = i_pro_deb; pro <= i_pro_fin; pro++)
	{
	        /*0         1         2         3         4    */
		/*12345678901234567890123456789012345678901234567890*/
		printf(tc_sep_tir);
	
		printf("\n%d\t",pro);

		printf("%c\t",(tpts_pie[ts_hst_pro[pro].i_cam]+ts_hst_pro[pro].i_Id)->c_lib_pie);


		
		printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_ori_n]);
		printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_n]);
		printf("%d\t",ts_hst_pro[pro].i_Id_2p);
			
		printf("\n\t");
		printf("%d\t",ts_hst_pro[pro].i_typ_mvt);
			
		printf("%d\t",ts_hst_pro[pro].i_ech_dir_pri);
		printf("%d\t",ts_hst_pro[pro].i_ech_dir_dem);
		printf("%d",ts_hst_pro[pro].i_ech_dir_dem_p_c);
		
		printf("\n\t");
		printf("%d\t",ts_hst_pro[pro].i_not);
		printf("%d\t",ts_hst_pro[pro].i_not_max);
		printf("%d\t",ts_hst_pro[pro].i_pat);
		printf("%d\t",ts_hst_pro[pro].i_mat);
		printf(  "ech:%d\t",ts_hst_pro[pro].i_ech);
		printf("Rf:%d\t",ts_hst_pro[pro].i_rap_for);
		printf("Rpc:%d",ts_hst_pro[pro].i_pos_n_R_p_c);
		
# if CPT_ITE == 1
		printf("cpt:%li",ts_hst_pro[pro].cpt);
# endif
	     	}

}
/*  Affichage  notes nouvelle version  */
int aff_not_1 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg;
  int cpt,cpt2;
  int i_fir_lig;
  /* type note  afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc
  };

  ST_NOT_MVT_INI *pts_mvt;
  struct st_aff *pts_aff=&tst_aff[e_aff_not_1];
  pts_aff->i_nbr_lig_pag=8;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_1;

  i_msg=ver_aff_not_pos();
  if(i_msg<0)  return i_msg;		
	
  printf("%s",tc_sep_tir);
  printf("\n");

  /* printf(" N pDeAr Not	"    */
  printf( LIB_NOT1_ENT );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);
 


 printf("%s",tc_sep_tir);

 /* dtermine la premire ligne  afficher */
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
              -
              pts_aff->i_cur_pag ; /*reafficher la dernire ligne */

  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<i_not_cpt_mvt_ini;
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* premire ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      printf( LIB_BLANC_1C );
      for (cpt2=0;cpt2<(int)( sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[BLANC]);
	}

      /* seconde ligne */
      printf("\n\t\t");
      printf( LIB_NOIR_1C );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	   print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[NOIR]);
	}
 	
	
    }
  /* mmorise si premire ou drenire page */
  if ((cpt+1)>= i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;

  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir);
 
  if(i_mei_mvt>=0)  
    /*printf("\nMei_mvt:%d->%s%s  Piece=%c  Camp=%d Niv=%d,%d ",*/
    printf("\n");

  printf( LIB_NOT_BAS_80 ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]
	   );
  if ( pts_aff->i_las_pag == FALSE)
    /*   printf(" Page suivant: +");*/
  printf( LIB_PAG_SUI );
 
 if ( pts_aff->i_fir_pag == FALSE)
   /*  printf(" Page precedent: -");*/
  printf( LIB_PAG_PRE );
 

  return 0;
}

/*  Affichage  notes nouvelle version  */
int aff_not_2 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg2;
  int cpt,cpt2;
  int i_fir_lig;
  int i_tot_coe;
  /* type note  afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    cou_pie, 
    nbr_fou, 
    mob_pie 	
  };


  ST_NOT_MVT_INI *pts_mvt;

  struct st_aff *pts_aff=&tst_aff[e_aff_not_2];

  pts_aff->i_nbr_lig_pag=10;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_2;
  i_msg2=ver_aff_not_pos();

  if(i_msg2<0)  return i_msg2;		
  printf("%s",tc_sep_tir_120);

  /* Coefficiant */
  printf("\n");
  printf( LIB_NOT2_COEF );
  printf("\t");
  i_tot_coe=0;
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    {
      i_tot_coe+= st_eva_sit.ti_coe_pon[te_tn[cpt2]];
      printf(" %9d", st_eva_sit.ti_coe_pon[te_tn[cpt2]]); 
    }
  printf(" %9d", i_tot_coe); 

  /* Entete de colone */
  printf("\n");
  printf( LIB_NOT2_ENT );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);
  /* Detail par mouvement */ 
  printf("%s",tc_sep_tir_120);
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
              -
               pts_aff->i_cur_pag ; /*reafficher la dernire ligne */
  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<i_not_cpt_mvt_ini;
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* premire ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
        print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_dif_pon);
      
      /* seconde ligne */
      printf("\n\t");
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	printf( "       %3d", pts_mvt->tst_not[te_tn[cpt2]].i_not_pon_rec);
      
       print_sci_nbr(pts_mvt->f_tot_rec_pon);
			
	
    }
  /* mmorise si premire ou drenire page */
  if ((cpt+1)>= i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;
  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir_120);

  /* valeur maximum */
  printf("\n");
  printf("%s", LIB_NOT2_MAX );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
     print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].max);

  /* Valeur minimum */
  printf("\n");
  printf("%s", LIB_NOT2_MIN );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
     print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].min);

  printf("%s",tc_sep_tir_120);

  if(i_mei_mvt>=0)  
  printf("\n");
  printf( LIB_NOT_BAS_80 ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]	
	  );
  printf("\t\t");
 
  if ( pts_aff->i_las_pag == FALSE)
    printf( LIB_PAG_SUI );

  if ( pts_aff->i_fir_pag == FALSE)
    printf( LIB_PAG_PRE );

  return 0;
}


void aff_nex_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];

  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_las_pag==FALSE)
	pts_aff->i_cur_pag++;
      else
	printf("\a"); /* alarme */

    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);
}
void aff_pre_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];
  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_fir_pag==FALSE)
	pts_aff->i_cur_pag--;
      else
	printf("\a"); /* alarme */
    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);

}
int aff_not_debug (void)
{
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;


  printf("\n%s",tc_sep_tir);
  /* traitement des donnes collectes dans hst */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];
      printf("\n%2u",pts_mvt->i_num_mvt);
		printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
		printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
		printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
		printf("%i",pts_mvt->i_nbr_rep_sit);	
	}
	
	  return 0;
}

int  aff_mvt_ini(int i_mvt_ini)
{  
  int i_msg;
  int cpt2;
  int p;		/* profondeur */
  ST_NOT_MVT_INI *pts_mvt;
  /* type note  afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mvt,
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    nbr_fou, 
  };


  /* Verification note disponible */
  i_msg=ver_aff_not_pos();
  if(i_msg<0)    return i_msg;

  /* verification existance mvt */
  i_msg=ver_exi_mvt_ini(i_mvt_ini);
  if(i_msg<0)    return i_msg;

  pts_mvt = &ts_not_mvt_ini[i_mvt_ini];  

  /* Affichage mvt */
  /*"Num:%i  Mvt:%c %s%s"*/
  printf( LIB_MVT_INI_MVT , 
	 i_mvt_ini,
	 pts_mvt->c_lib_pie,
	 tc_lib_cas[pts_mvt->i_pos_ori_n],
	 tc_lib_cas[pts_mvt->i_pos_arr_n]
	 );

  /* affichage entete de colone */
  printf("%s",tc_sep_tir);
  printf("\n");
  /*   printf(" p I C ");*/
  printf( LIB_MVT_PRO_INC_CAM );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);


  printf("%s",tc_sep_tir);

  /*affichage du dtail par profondeur */

  for(p=0;p< (pts_mvt->i_pro_sim+pts_mvt->i_inc_pro_sim-1);p++)
    {
      printf("\n");
      printf ("%2i ",p+2);
      printf ("%i  ",pts_mvt->tst_pro_sta[p].i_inc);
      if (pts_mvt->tst_pro_sta[p].i_cam == BLANC)
	printf ( LIB_BLANC_1C );
      else
	printf ( LIB_NOIR_1C );
     for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    {
      print_sci_nbr( pts_mvt->tst_pro_sta[p].f_dat_pro[te_tn[cpt2]]);
    }


    }
  return 0;
}

/* Affichage calcul en cours */
void aff_cal_en_cou(int i_not_cpt_mvt_ini)
{
  if(i_aff_cal_cou == 1 )
    {
	#if CPT_ITE == 1
	printf("\nmvt %s%s  num:%i cpt_ite:%li",
	       tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n],
	       tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n],
	       i_not_cpt_mvt_ini,
	       cpt);
	#else
		printf("\nnum:");
		printf("%2i: ",i_not_cpt_mvt_ini);
		printf(" mvt:");
		printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n]);
		printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n]);
	
	#endif
    }
}

void sto_sim_msg(void)
{
  fflush(stdin);
  /* \nVoulez vous interrompre le calcul? (O/N) */
  printf(tc_sep_ast);
  printf("\n");
  printf( LIB_QST_INT_CAL );
  printf(tc_sep_ast);
  printf("\n");
  /* getchar();*/
  if( tolower(getchar()) == CDE_OUI )
      sto_sim();
  else
    i_sto_sim_cla = 0;
}

/* Choix remplacement du pion */
/* Verifie si piece de promotion est ok sinon demande interactive */
/* et traduction lib piece vers type piece */
	
char  pro_pio_cho (void)
{
  int i_msg=0;
  int c;

    c=getchar(); /* bricolage! */
      /* Quelle piece voulez vous pour remplacer le pion? */
      printf(tc_sep_ast);
      printf("\n");
      printf( LIB_QST_PRO_PIO );
      printf(tc_sep_ast);
      printf("\n");
      
     while (1)
	{
	 fflush(stdin);

	 c=getchar();
	  
	  i_msg=pro_pio_ver_lib_pie(c);

	  if(i_msg>=0)
	    return (pro_pio_tra_lpie_tpie(c));
	  else
	    aff_mes_uti(i_msg);
	  printf("\n");
	   
	}
 
}

/* Affichage message utilisateur  */
void aff_mes_uti(int i_mes_num)
{
  /*recupere le texte du message */
  char tc_lib_mes[LEN_MES];
  cha_mes (i_mes_num, tc_lib_mes);
 

  printf("%s",tc_sep_ast);
  printf("\n%s",tc_lib_mes);

  printf("%s",tc_sep_ast);
  printf("\a"); /* alarme */
}
void for_nul_sci_nbr (char *str)  
{
  /* si valeur nulle supprime la notation sciatifique */
  if (strcmp(str,"+0.00e+00")==0)
    strcpy(str,  "        0");
}
void print_sci_nbr (float f_nbr)
{
  /* Imprime un nombre de type float 
     si la vlaeur = 0 supprime la notation scientifique */ 
  char tc_nbr[11]; 
  sprintf(tc_nbr,"%+2.2e",f_nbr);
  for_nul_sci_nbr(tc_nbr);
  printf(" %s",tc_nbr);
}
void sup_blanc(char *tc_str)
{
  /* supprime les blanc de la zone de saisie */
  int i=0;
  int ii=0;
  for(i=0;i<=(int)strlen(tc_str);i++)
    {   
      if(tc_str[i]!=' ')
	{
	  tc_str[ii++]=tc_str[i];
	}
    }
  tc_str[ii]='\0';
}
void sai_com (char tc_com [80])
{
  int i=0;
  int c;
  
  while(1) 
    {  
      c=getchar();
      
      if (c !=10 && i<78 )
	tc_com[i++]=c;
      else 
	break;
    }	
  tc_com[i]='\0';
  sup_blanc(tc_com);

}
